commit f66e6b91387458bce604701715ad77543fcda071
Author: jklowden <jklowden>
Date:   Sat Apr 18 19:35:38 2009 +0000

    support TDSEINTF and TDSEUHST to distinguish name-lookup failures.

diff --git a/ChangeLog b/ChangeLog
index 6086d57..629cef5 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,10 @@
+Sat Apr 18 15:18:39 EDT 2009	JK Lowden <jklowden@freetds.org>
+	* include/sybdb.h include/tds.h
+	* src/apps/bsqldb.c src/apps/tsql.c
+	* src/ctlib/ct.c src/dblib/dblib.c src/odbc/odbc.c
+	* src/tds/config.c src/tds/login.c src/tds/util.c
+	- support TDSEINTF and TDSEUHST to distinguish name-lookup failures.
+
 Sat Apr 18 17:21:15 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/dblib/unittests/timeout.c:
 	- fix test according to vendors behavior
@@ -1484,4 +1491,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2771 2009/04/18 15:21:49 freddy77 Exp $
+$Id: ChangeLog,v 1.2772 2009/04/18 19:35:38 jklowden Exp $
diff --git a/include/sybdb.h b/include/sybdb.h
index fc3dd4b..d642612 100644
--- a/include/sybdb.h
+++ b/include/sybdb.h
@@ -41,7 +41,7 @@ extern "C"
 #define TDS_STATIC_CAST(type, a) ((type)(a))
 #endif
 
-static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.89 2009/02/28 17:38:39 jklowden Exp $";
+static const char rcsid_sybdb_h[] = "$Id: sybdb.h,v 1.90 2009/04/18 19:35:38 jklowden Exp $";
 static const void *const no_unused_sybdb_h_warn[] = { rcsid_sybdb_h, no_unused_sybdb_h_warn };
 
 #ifdef FALSE
@@ -555,7 +555,6 @@ char *dbtabname(DBPROCESS * dbprocess, int tabnum);
 char *dbtabsoruce(DBPROCESS * dbprocess, int colnum, int *tabnum);
 
 RETCODE dbsetlshort(LOGINREC * login, int value, int which);
-#define DBSETLHIER(x,y)		dbsetlshort((x), (y), DBSETHIER)
 
 RETCODE dbsendpassthru(DBPROCESS * dbprocess, DBVOIDPTR bufp);
 RETCODE dbrecvpassthru(DBPROCESS * dbprocess, DBVOIDPTR * bufp);
@@ -1113,8 +1112,10 @@ RETCODE dbsetlversion (LOGINREC * login, BYTE version);
 #define DBSETPWD		3
 #define DBSETLPWD(x,y)		dbsetlname((x), (y), DBSETPWD)
 #define dbsetlpwd(x,y)		dbsetlname((x), (y), DBSETPWD)
-#define DBSETHID		4	/* not implemented */
-#define DBSETLHID(x,y)		dbsetlname((x), (y), DBSETHID)
+#if defined(DBLIB_UNIMPLEMENTED)
+# define DBSETHID		4	/* not implemented */
+# define DBSETLHID(x,y)		dbsetlname((x), (y), DBSETHID)
+#endif
 #define DBSETAPP		5
 #define DBSETLAPP(x,y)		dbsetlname((x), (y), DBSETAPP)
 #define dbsetlapp(x,y)		dbsetlname((x), (y), DBSETAPP)
@@ -1124,9 +1125,12 @@ RETCODE dbsetlversion (LOGINREC * login, BYTE version);
 #define DBSETNATLANG		7	
 #define DBSETLNATLANG(x,y)	dbsetlname((x), (y), DBSETNATLANG)
 #define dbsetlnatlang(x,y)	dbsetlname((x), (y), DBSETNATLANG)
-#define DBSETNOSHORT		8	/* not implemented */
-#define DBSETLNOSHORT(x,y)	dbsetlbool((x), (y), DBSETNOSHORT)
-#define DBSETHIER		9	/* not implemented */
+#if defined(DBLIB_UNIMPLEMENTED)
+# define DBSETNOSHORT		8	/* not implemented */
+# define DBSETLNOSHORT(x,y)	dbsetlbool((x), (y), DBSETNOSHORT)
+# define DBSETHIER		9	/* not implemented */
+# define DBSETLHIER(x,y)	dbsetlshort((x), (y), DBSETHIER)
+#endif
 #define DBSETCHARSET		10
 #define DBSETLCHARSET(x,y)	dbsetlname((x), (y), DBSETCHARSET)
 #define DBSETPACKET		11
diff --git a/include/tds.h b/include/tds.h
index 8f7d4b5..9b31c4f 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.312 2009/02/28 17:38:50 jklowden Exp $ */
+/* $Id: tds.h,v 1.313 2009/04/18 19:35:38 jklowden Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -296,6 +296,8 @@ typedef enum {	TDSEOK    = TDS_SUCCEED,
 		TDSESOCK = 20008, 
 		TDSECONN = 20009, 
 		TDSEMEM  = 20010,
+		TDSEINTF = 20012,	/* Server name not found in interface file */
+		TDSEUHST = 20013,	/* Unknown host machine name. */
 		TDSEPWD  = 20014, 
 		TDSESEOF = 20017, 
 		TDSERPND = 20019, 
diff --git a/src/apps/bsqldb.c b/src/apps/bsqldb.c
index 00e8a8e..630bda4 100644
--- a/src/apps/bsqldb.c
+++ b/src/apps/bsqldb.c
@@ -45,7 +45,7 @@
 #include <sybdb.h>
 #include "replacements.h"
 
-static char software_version[] = "$Id: bsqldb.c,v 1.34 2009/01/12 08:15:52 freddy77 Exp $";
+static char software_version[] = "$Id: bsqldb.c,v 1.35 2009/04/18 19:35:38 jklowden Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 int err_handler(DBPROCESS * dbproc, int severity, int dberr, int oserr, char *dberrstr, char *oserrstr);
@@ -112,16 +112,15 @@ main(int argc, char *argv[])
 		exit(1);
 	}
 	
+	/* Install our error and message handlers */
+	dberrhandle(err_handler);
+	dbmsghandle(msg_handler);
 
 	memset(&options, 0, sizeof(options));
 	options.headers = stderr;
 	login = get_login(argc, argv, &options); /* get command-line parameters and call dblogin() */
 	assert(login != NULL);
 
-	/* Install our error and message handlers */
-	dberrhandle(err_handler);
-	dbmsghandle(msg_handler);
-
 	/* 
 	 * Override stdin, stdout, and stderr, as required 
 	 */
@@ -163,8 +162,8 @@ main(int argc, char *argv[])
 	/* 
 	 * Connect to the server 
 	 */
-	dbproc = dbopen(login, options.servername);
-	assert(dbproc != NULL);
+	if ((dbproc = dbopen(login, options.servername)) == NULL)
+		return 1;
 	
 	/* Switch to the specified database, if any */
 	if (options.database)
diff --git a/src/apps/tsql.c b/src/apps/tsql.c
index 455bf2d..0e86a68 100644
--- a/src/apps/tsql.c
+++ b/src/apps/tsql.c
@@ -85,7 +85,7 @@
 #include "tdsconvert.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: tsql.c,v 1.126 2009/01/12 08:09:50 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tsql.c,v 1.127 2009/04/18 19:35:38 jklowden Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -697,8 +697,9 @@ main(int argc, char **argv)
 
 	/* Try to open a connection */
 	tds = tds_alloc_socket(context, 512);
+	assert(tds);
 	tds_set_parent(tds, NULL);
-	connection = tds_read_config_info(NULL, login, context->locale);
+	connection = tds_read_config_info(tds, login, context->locale);
 
 	if (opt_default_db) {
 		tds_dstr_copy(&connection->database, opt_default_db);
@@ -707,8 +708,7 @@ main(int argc, char **argv)
 
 	/* 
 	 * If we're able to establish an ip address for the server, we'll try to connect to it. 
-	 * If that machine is currently unreachable
-	 * show a timer connecting to the server 
+	 * If that machine is currently unreachable, show a timer connecting to the server. 
 	 */
 #if HAVE_FORK
 	if (connection && !QUIET) {
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index 46c3dea..bc7d306 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.185 2008/12/19 10:37:51 freddy77 Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.186 2009/04/18 19:35:38 jklowden Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -586,7 +586,7 @@ ct_connect(CS_CONNECTION * con, CS_CHAR * servername, CS_INT snamelen)
 	if (!(con->tds_socket = tds_alloc_socket(ctx->tds_ctx, 512)))
 		return CS_FAIL;
 	tds_set_parent(con->tds_socket, (void *) con);
-	if (!(connection = tds_read_config_info(NULL, con->tds_login, ctx->tds_ctx->locale))) {
+	if (!(connection = tds_read_config_info(con->tds_socket, con->tds_login, ctx->tds_ctx->locale))) {
 		tds_free_socket(con->tds_socket);
 		con->tds_socket = NULL;
 		return CS_FAIL;
diff --git a/src/dblib/dblib.c b/src/dblib/dblib.c
index 88c4215..4561669 100644
--- a/src/dblib/dblib.c
+++ b/src/dblib/dblib.c
@@ -75,7 +75,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: dblib.c,v 1.346 2009/03/24 01:22:14 jklowden Exp $");
+TDS_RCSID(var, "$Id: dblib.c,v 1.347 2009/04/18 19:35:38 jklowden Exp $");
 
 static RETCODE _dbresults(DBPROCESS * dbproc);
 static int _db_get_server_type(int bindtype);
@@ -747,6 +747,11 @@ dbsetlname(LOGINREC * login, const char *value, int which)
 		return FAIL;
 	}
 
+	if (TDS_MAX_LOGIN_STR_SZ < strlen(value)) {
+		dbperror(NULL, SYBENTLL, 0);
+		return FAIL;
+	}
+
 	switch (which) {
 	case DBSETHOST:
 		tds_set_host(login->tds_login, value);
@@ -772,7 +777,6 @@ dbsetlname(LOGINREC * login, const char *value, int which)
 		tds_set_language(login->tds_login, value);
 		return SUCCEED;
 		break;
-	case DBSETHID:
 	default:
 		dbperror(NULL, SYBEASUL, 0); /* Attempt to set unknown LOGINREC field */
 		return FAIL;
@@ -862,7 +866,6 @@ dbsetlbool(LOGINREC * login, int value, int which)
 		tds_set_bulk(login->tds_login, (TDS_TINYINT) value);
 		return SUCCEED;
 		break;
-	case DBSETNOSHORT:
 	case DBSETENCRYPT:
 	case DBSETLABELED:
 	default:
@@ -1127,7 +1130,11 @@ tdsdbopen(LOGINREC * login, const char *server, int msdblib)
 
 	tds_set_server(login->tds_login, server);
 
-	dbproc->tds_socket = tds_alloc_socket(dblib_get_tds_ctx(), 512);
+	if ((dbproc->tds_socket = tds_alloc_socket(dblib_get_tds_ctx(), 512)) == NULL ){
+		dbperror(NULL, SYBEMEM, 0);
+		return NULL;
+	}
+	
 
 	tds_set_parent(dbproc->tds_socket, dbproc);
 	dbproc->tds_socket->option_flag2 &= ~0x02;	/* we're not an ODBC driver */
@@ -1136,7 +1143,7 @@ tdsdbopen(LOGINREC * login, const char *server, int msdblib)
 	dbproc->dbcurdb[0] = '\0';
 	dbproc->servcharset[0] = '\0';
 
-	connection = tds_read_config_info(NULL, login->tds_login, g_dblib_ctx.tds_ctx->locale);
+	connection = tds_read_config_info(dbproc->tds_socket, login->tds_login, g_dblib_ctx.tds_ctx->locale);
 	if (!connection) {
 		dbclose(dbproc);
 		return NULL;
@@ -7626,7 +7633,7 @@ static const DBLIB_ERROR_MESSAGE dblib_error_messages[] =
 	, { SYBEIMCL,       EXCONSISTENCY,	"Illegal money column length returned by Adaptive Server. Legal money lengths are 4 "
 						"and 8 bytes\0" }
 	, { SYBEINLN,              EXUSER,	"Interface file: unexpected end-of-line\0" }
-	, { SYBEINTF,              EXUSER,	"Server name not found in interface file\0" }
+	, { SYBEINTF,              EXUSER,	"Server name not found in configuration files\0" }
 	, { SYBEINUMCL,     EXCONSISTENCY,	"Invalid numeric column length returned by the server\0" }
 	, { SYBEIPV,               EXINFO,	"%1! is an illegal value for the %2! parameter of %3!\0%d %s %s" }
 	, { SYBEISOI,       EXCONSISTENCY,	"International Release: Invalid sort-order information found\0" }
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 04a556b..2ab668a 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.509 2009/02/23 16:08:34 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.510 2009/04/18 19:35:38 jklowden Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -1871,7 +1871,7 @@ _SQLColAttribute(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLUSMALLINT fDescType, SQLP
 	}
 	drec = &ird->records[icol - 1];
 
-	tdsdump_log(TDS_DBG_INFO1, "odbc:SQLColAttribute: fDescType is %d\n", fDescType);
+	tdsdump_log(TDS_DBG_INFO1, "SQLColAttribute: fDescType is %d\n", fDescType);
 
 	switch (fDescType) {
 	case SQL_DESC_AUTO_UNIQUE_VALUE:
@@ -2021,7 +2021,7 @@ _SQLColAttribute(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLUSMALLINT fDescType, SQLP
 		IOUT(SQLSMALLINT, drec->sql_desc_updatable);
 		break;
 	default:
-		tdsdump_log(TDS_DBG_INFO2, "odbc:SQLColAttribute: fDescType %d not catered for...\n", fDescType);
+		tdsdump_log(TDS_DBG_INFO2, "SQLColAttribute: fDescType %d not catered for...\n", fDescType);
 		odbc_errs_add(&stmt->errs, "HY091", NULL);
 		ODBC_RETURN(stmt, SQL_ERROR);
 		break;
@@ -2352,7 +2352,7 @@ SQLGetDescField(SQLHDESC hdesc, SQLSMALLINT icol, SQLSMALLINT fDescType, SQLPOIN
 		ODBC_RETURN(desc, SQL_NO_DATA);
 	drec = &desc->records[icol - 1];
 
-	tdsdump_log(TDS_DBG_INFO1, "odbc:SQLGetDescField: fDescType is %d\n", fDescType);
+	tdsdump_log(TDS_DBG_INFO1, "SQLGetDescField: fDescType is %d\n", fDescType);
 
 	switch (fDescType) {
 	case SQL_DESC_AUTO_UNIQUE_VALUE:
@@ -2567,7 +2567,7 @@ SQLSetDescField(SQLHDESC hdesc, SQLSMALLINT icol, SQLSMALLINT fDescType, SQLPOIN
 	}
 	drec = &desc->records[icol - 1];
 
-	tdsdump_log(TDS_DBG_INFO1, "odbc:SQLColAttributes: fDescType is %d\n", fDescType);
+	tdsdump_log(TDS_DBG_INFO1, "SQLColAttributes: fDescType is %d\n", fDescType);
 
 	switch (fDescType) {
 	case SQL_DESC_AUTO_UNIQUE_VALUE:
@@ -3860,7 +3860,7 @@ _SQLFreeStmt(SQLHSTMT hstmt, SQLUSMALLINT fOption, int force)
 
 	/* check if option correct */
 	if (fOption != SQL_DROP && fOption != SQL_CLOSE && fOption != SQL_UNBIND && fOption != SQL_RESET_PARAMS) {
-		tdsdump_log(TDS_DBG_ERROR, "odbc:SQLFreeStmt: Unknown option %d\n", fOption);
+		tdsdump_log(TDS_DBG_ERROR, "SQLFreeStmt: Unknown option %d\n", fOption);
 		odbc_errs_add(&stmt->errs, "HY092", NULL);
 		ODBC_RETURN(stmt, SQL_ERROR);
 	}
@@ -4874,7 +4874,7 @@ SQLGetFunctions(SQLHDBC hdbc, SQLUSMALLINT fFunction, SQLUSMALLINT FAR * pfExist
 #endif
 
 	case SQL_API_ALL_FUNCTIONS:
-		tdsdump_log(TDS_DBG_FUNC, "odbc:SQLGetFunctions: " "fFunction is SQL_API_ALL_FUNCTIONS\n");
+		tdsdump_log(TDS_DBG_FUNC, "SQLGetFunctions: " "fFunction is SQL_API_ALL_FUNCTIONS\n");
 		for (i = 0; i < 100; ++i) {
 			pfExists[i] = SQL_FALSE;
 		}
@@ -6671,7 +6671,7 @@ odbc_log_unimplemented_type(const char function_name[], int fType)
 		break;
 	}
 
-	tdsdump_log(TDS_DBG_INFO1, "odbc: not implemented: %s: option/type %d(%s) [category %s]\n", function_name, fType, name,
+	tdsdump_log(TDS_DBG_INFO1, "not implemented: %s: option/type %d(%s) [category %s]\n", function_name, fType, name,
 		    category);
 
 	return;
diff --git a/src/tds/config.c b/src/tds/config.c
index a7979ec..8baab11 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.142 2009/03/06 14:32:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.143 2009/04/18 19:35:38 jklowden Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -84,7 +84,7 @@ static void tds_config_env_tdsver(TDSCONNECTION * connection);
 static void tds_config_env_tdsport(TDSCONNECTION * connection);
 static void tds_config_env_tdshost(TDSCONNECTION * connection);
 static int tds_read_conf_sections(FILE * in, const char *server, TDSCONNECTION * connection);
-static void tds_read_interfaces(const char *server, TDSCONNECTION * connection);
+static int tds_read_interfaces(const char *server, TDSCONNECTION * connection);
 static int tds_config_boolean(const char *value);
 static int parse_server_name_for_port(TDSCONNECTION * connection, TDSLOGIN * login);
 static int tds_lookup_port(const char *portname);
@@ -192,7 +192,11 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 	if (!tds_read_conf_file(connection, tds_dstr_cstr(&login->server_name))) {
 		/* fallback to interfaces file */
 		tdsdump_log(TDS_DBG_INFO1, "Failed in reading conf file.  Trying interface files.\n");
-		tds_read_interfaces(tds_dstr_cstr(&login->server_name), connection);
+		if (!tds_read_interfaces(tds_dstr_cstr(&login->server_name), connection)) {
+			tdsdump_log(TDS_DBG_INFO1, "Failed to find [%s] in configuration files; trying '%s' instead.\n", 
+						   tds_dstr_cstr(&login->server_name), tds_dstr_cstr(&connection->server_name));
+			tdserror(tds->tds_ctx, tds, TDSEINTF, 0);
+		}
 	}
 
 	/* Override config file settings with environment variables. */
@@ -200,7 +204,7 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 
 	/* And finally apply anything from the login structure */
 	tds_config_login(connection, login);
-
+	
 	if (opened) {
 		tdsdump_log(TDS_DBG_INFO1, "Final connection parameters:\n");
 		tdsdump_log(TDS_DBG_INFO1, "\t%20s = %s\n", "server_name", tds_dstr_cstr(&connection->server_name));
@@ -235,6 +239,16 @@ tds_read_config_info(TDSSOCKET * tds, TDSLOGIN * login, TDSLOCALE * locale)
 
 		tdsdump_close();
 	}
+
+	/*
+	 * If a dump file has been specified, start logging
+	 */
+	if (!tds_dstr_isempty(&connection->dump_file) && !tdsdump_isopen()) {
+		if (connection->debug_flags)
+			tds_debug_flags = connection->debug_flags;
+		tdsdump_open(tds_dstr_cstr(&connection->dump_file));
+	}
+
 	return connection;
 }
 
@@ -744,8 +758,9 @@ tds_set_interfaces_file_loc(const char *interf)
 }
 
 /**
- * Given a servername lookup the hostname. The server ip will be stored 
- * in the string 'ip' in dotted-decimal notation.
+ * Get the IP address for a hostname. Store server's IP address 
+ * in the string 'ip' in dotted-decimal notation.  (The "hostname" might itself
+ * be a dotted-decimal address.  
  *
  * If we can't determine the IP address then 'ip' will be set to empty
  * string.
@@ -765,8 +780,8 @@ tds_lookup_host(const char *servername,	/* (I) name of the server
 	int h_errnop;
 
 	/*
-	 * Only call gethostbyname if servername is not an ip address. 
-	 * This call take a while and is useless for an ip address.
+	 * Call gethostbyname(3) only if servername is not an ip address. 
+	 * This call takes a while and is useless for an ip address.
 	 * mlilback 3/2/02
 	 */
 	ip_addr = inet_addr(servername);
@@ -783,7 +798,7 @@ tds_lookup_host(const char *servername,	/* (I) name of the server
 
 		tds_inet_ntoa_r(*ptr, ip, 17);
 	}
-}				/* tds_lookup_host()  */
+}
 
 /**
  * Given a portname lookup the port.
@@ -952,7 +967,7 @@ search_interface_file(TDSCONNECTION * connection, const char *dir, const char *f
  *
  * @note This function uses only the interfaces file and is deprecated.
  */
-static void
+static int
 tds_read_interfaces(const char *server, TDSCONNECTION * connection)
 {
 	int found = 0;
@@ -1045,7 +1060,7 @@ tds_read_interfaces(const char *server, TDSCONNECTION * connection)
 			tdsdump_log(TDS_DBG_INFO1, "Setting 'ip_port' to %d as a guess.\n", ip_port);
 
 		/*
-		 * lookup the host
+		 * look up the host
 		 */
 		tds_lookup_host(server, ip_addr);
 		if (ip_addr[0]) {
@@ -1055,6 +1070,8 @@ tds_read_interfaces(const char *server, TDSCONNECTION * connection)
 		if (ip_port)
 			connection->port = ip_port;
 	}
+
+	return found;
 }
 
 /**
diff --git a/src/tds/login.c b/src/tds/login.c
index 8da8d10..ccaa74b 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.182 2009/02/28 17:38:50 jklowden Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.183 2009/04/18 19:35:38 jklowden Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -426,6 +426,7 @@ tds_connect_and_login(TDSSOCKET * tds, TDSCONNECTION * connection)
 
 	/* verify that ip_addr is not empty */
 	if (tds_dstr_isempty(&connection->ip_addr)) {
+		tdserror(tds->tds_ctx, tds, TDSEUHST, 0 );
 		tdsdump_log(TDS_DBG_ERROR, "IP address pointer is empty\n");
 		if (!tds_dstr_isempty(&connection->server_name)) {
 			tdsdump_log(TDS_DBG_ERROR, "Server %s not found!\n", tds_dstr_cstr(&connection->server_name));
diff --git a/src/tds/util.c b/src/tds/util.c
index 679c404..6b6cd48 100644
--- a/src/tds/util.c
+++ b/src/tds/util.c
@@ -65,7 +65,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: util.c,v 1.85 2008/12/16 09:21:08 freddy77 Exp $");
+TDS_RCSID(var, "$Id: util.c,v 1.86 2009/04/18 19:35:38 jklowden Exp $");
 
 void
 tds_set_parent(TDSSOCKET * tds, void *the_parent)
@@ -268,8 +268,10 @@ static const TDS_ERROR_MESSAGE tds_error_messages[] =
 	, { TDSEREAD,              EXCOMM,	"Read from the server failed" }
 	, { TDSETIME,              EXTIME,	"Adaptive Server connection timed out" }
 	, { TDSESEOF,              EXCOMM,	"Unexpected EOF from the server" }
+	, { TDSEINTF,          	   EXUSER,	"Server name not found in configuration files." }
 	, { TDSESOCK,              EXCOMM,	"Unable to open socket" }
 	, { TDSESYNC,              EXCOMM,	"Read attempted while out of synchronization with Adaptive Server" }
+	, { TDSEUHST,	           EXUSER,	"Unknown host machine name." }
 	, { TDSEUMSG,              EXCOMM,	"Unknown message-id in MSG datastream" }
 	, { TDSEUSCT,              EXCOMM,	"Unable to set communications timer" }
 	, { TDSEUTDS,              EXCOMM,	"Unrecognized TDS version received from the server" }

